﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DelegateTest
{
    class Program
    {
        //デリゲート型の宣言
        public delegate void Calc(int num1, int num2);
        
        //計算機メソッドの定義
        public static void Calculation(Calc calc, int num1, int num2)
        {
            Console.WriteLine("計算を開始します。。。");
            calc(num1, num2);
            Console.WriteLine();
        }

        static void Main(string[] args)
        {
            //デリゲート型の変数を宣言
            Calc calc;

            //計算用の変数を宣言
            int data1, data2;

            while (true)
            {
                //メニューを表示
                Console.Write("1)加算　2)減算　9)両方　その他)終了：");
                string menunum = Console.ReadLine();

                try
                {
                    if (!(menunum == "1" || menunum == "2" || menunum == "9"))
                    {
                        return;
                    }

                    //2つの数字を入力
                    Console.Write("1つ目のデータ：");
                    data1 = Int32.Parse(Console.ReadLine());
                    Console.Write("2つ目のデータ：");
                    data2 = Int32.Parse(Console.ReadLine());

                    switch(menunum)
                    {
                        case "1":
                            //加算メソッドをデリゲートにセット
                            calc = (dt1, dt2)  => Console.WriteLine("足し算の結果は" + (dt1 + dt2) + "です。");
                            break;
                        case "2":
                            //減算メソッドをデリゲートにセット
                            calc = (dt1, dt2) => Console.WriteLine("引き算の結果は" + (dt1 - dt2) + "です。");
                            break;
                        case "9":
                            //加算・減算メソッドをデリゲートにセット
                            calc = (dt1, dt2) => Console.WriteLine("足し算の結果は" + (dt1 + dt2) + "です。");
                            calc += (dt1, dt2) => Console.WriteLine("引き算の結果は" + (dt1 - dt2) + "です。");
                            break;
                        default:
                            return;
                    }

                    //計算機メソッドを実行
                    Calculation(calc, data1, data2);
                }
                catch(Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
        }
    }
}
